#include <a0format.h>

a0tPort myport;
a0tFormat myformat;

int main(int argc, char *argv[]) {
  int i, r;
  float f;
  a0tRequest req;
  struct {
    int i;
    float f;
    char tab[40];
  } str;

  a0Init(&argc, &argv);
  a0UseFormats();
  a0NewPort(&myport, 1, 0);
  a0NewFormat(&myformat, A0ListMap, &str,
		1,  A0FInt,	&str.i,
		1,  A0FFloat,	&str.f,
		40, A0FChar,	str.tab,
		0);
  a0InitCommit();

  /* init a different random seed each node */
  srand(a0SelfNode * time(NULL));

  if (!a0SelfNode) {
    /* receive all random numbers */
    for (i=1; i<a0NodeCount; i++) {
      a0FReceive(&myport, i, 0, &req, A0FInt, &r, 1);
      a0FReceive(&myport, i, 0, &req, A0FFloat, &f, 1);
      printf("received %d and %f from %d.\n", r, f, i);

      a0FReceive(&myport, i, 0, &req, &myformat, &str, 1);
      printf("received [%d,%f,%s]\n", str.i, str.f, str.tab);
    }
  }
  else {
    r = rand();
    f = a0SelfNode;
    a0FSend(&myport, 0, 0, &req, A0FInt, &r, 1);
    a0FSend(&myport, 0, 0, &req, A0FFloat, &f, 1);
    str.i = r;
    str.f = f;
    gethostname(str.tab, 39);
    str.tab[39] = 0;
    a0FSend(&myport, 0, 0, &req, &myformat, &str, 1);
  }
  a0Terminate();
}
