/*
 * Parser.h: Header file to parser.c
 *
 * parser.c has routines used to parse the command line looking for its options
 * and arguments.Basically they identify options in a simple form "-name <arg>" 
 * or a list form, like, "-name <arg1> <arg2> <arg3> ...".
 *
 * These functions DOESN'T CHANGE argc and argv arguments.
 *
 * by Alexandre Carissimi
 * Apache Project, IMAG, Grenoble, France
 * April 15,1997
 *
 * Modified on:
 *	06/04/98: includes double arguments on single and list forms
 *
 */

#ifndef _PARSER
#define _PARSER

#include	<string.h>
  
int ArgFindName(int argc, char **argv, char *name);
int ArgGetStr(int argc, char **argv, char *name, char **str);
int ArgGetInt(int argc, char **argv, char *name, int *val);
int ArgGetIntList(int argc, char **argv, char *name, int n, int *val);
int ArgGetDouble(int argc, char **argv, char *name, double *val);
int ArgGetDoubleList(int argc, char **argv, char *name, int n, double *val);

#endif		/*_PARSER*/
