#include <stdio.h>
#include <ctype.h>
#include <time.h>

/* cv.c, by Pasin@IMAG.fr, mar/1996 */

/* This program converts files from a very reduced LaTeX
   subset to HTML. It also converts files using the manual
   macros that I defined. */

/* I'd suggest you don't try to understand it. It's probably
   better rewrite. I didn't have the time to make it better. */

/* delimiters (1 bit each) */
#define SLASH 	1
#define OPENBRA 2
#define CLOSEBRA 4
#define SLAEND 8
#define WHITEL 16
#define ALLDELIM 255

int html = 0;

int section = 0;
int subsection = 0;
int seccount = 0;
char outname[80];
char reffile[80] = "";
fpos_t lastcomm;
int intab = 0;
int intabtt = 0;
char *version;

void intbra(FILE *in, FILE *out);
void intbeg(FILE *in, FILE *out);
void intsec(FILE *in, FILE *out, char *closebra, int insec);


/******************/

typedef struct _footnote_t {
  fpos_t mark[10];
  int count;
  struct _footnote_t *next;
} footnote_t;

footnote_t *curr_ftn;

void pushfootnote(footnote_t *new) {
  new->next = curr_ftn;
  curr_ftn = new;
  new->count = 0;
}

int addfootnote(FILE *in) {
  fgetpos(in, &(curr_ftn->mark[curr_ftn->count++]));
  return curr_ftn->count;
}

void dumpfootnotes(FILE *in, FILE *out) {
  int n;
  fpos_t curr;

  if (curr_ftn->count) {
    fprintf(out, "<p><hr noshade></p>\n<p>");
    fgetpos(in, &curr);
    for (n=0; n<curr_ftn->count; n++) {
      fprintf(out, "<sup><font size=-2>%d</font></sup> "
		   "<font size=-1>\n", n+1);
      fsetpos(in, &(curr_ftn->mark[n]));
      intbra(in, out);
      fprintf(out, "<br>\n", n+1);
    }
    fprintf(out, "</p>\n", n+1);
    fsetpos(in, &curr);
  }
  curr_ftn = curr_ftn->next;
}

/* function that skips input until a given string */

void skip(FILE *file, char *str) {
  int len, match, c;

  match = 0;
  len = strlen(str);
  while (match<len) {
    c = fgetc(file);
    if (c == str[match]) match++;
    else match = 0;
  }
}


void getto(FILE *file, char *str, char *res) {
  int len, match, c, r;

  match = r = 0;
  len = strlen(str);
  while (match<len) {
    c = fgetc(file); if (c == '\\') c = fgetc(file);
    if (c == str[match]) match++;
    else match = 0;
    *res++ = c;
  }
  *res = 0;
}


int gettokenbra(FILE *in, char *tok) {
  int c;

  while (1) {
    c = fgetc(in);
    if (isalnum(c) || (c == '}')) break;
  }
  *tok++ = c;
  while (c != '}') {
    c = fgetc(in);
    if (c=='\\') c = fgetc(in);
    if (!(isalnum(c) || (c=='(') || (c=='_') || (c==')'))) break;
    *tok++ = c;
  }
  if (c == '}') tok--;
  *tok = 0;
  return (c=='}')? 1: 0;
}


/* function that copies until a delimiter */

int copy(FILE *file, FILE *out, int delim) {
  int c, skip = 0;
  static int last = 0;
  char command[256];
  fpos_t lastpos;

  while (1) {
    fgetpos(file, &lastpos);
    c = fgetc(file);
    if (feof(file)) return -1;
    if (skip) {
      if (c == '\n') skip = 0;
      else continue;
    }
    if ((last == '\n') && (c == '%')) {
      skip = 1;
      continue;
    }
    last = c;
    switch (c) {
    case '\\':
	if (delim & SLASH) {
	  memcpy(&lastcomm, &lastpos, sizeof(fpos_t));
	  return SLASH;
	}
	if (delim & SLAEND) {
	  for (c=0; c<3; c++) command[c] = fgetc(file);
	  command[3] = 0;
	  if (!strcmp("end", command)) {
	    return SLAEND;
	  }
	}
	fprintf(out, "\\%s", command);
	if (delim & SLASH) return SLASH;
	c = 0;
	break;
    case '{':
	if (delim & OPENBRA) return OPENBRA;
	break;
    case '}':
	if (delim & CLOSEBRA) return CLOSEBRA;
	break;
    case '<':
    	if (!html) {
          fprintf(out, "&lt;");
          c = 0;
        }
    case '&':
    	if (!html && intab) {
          fprintf(out, "<td>");
	  if (intabtt) fprintf(out, "<tt>");
          c = 0;
        }
        break;
    case '\n':
	if (delim & WHITEL) {
	  c = fgetc(file);
	  if (c == '\n') return WHITEL;
	  fputc('\n', out);
	  ungetc(c, file);
	  c = 0;
	}
	break;  
    }
    if (c) fputc(c, out);
  }
}


/* function that reads a LaTeX style command (\blabla) */

int getcom(FILE *file, char *cmd) {
  int c;
  int notyet = 1;
  int onecom = 0;
  char onechars[] = "\\_& ";

  while (1) {
    c = fgetc(file);
    if (feof(file)) return -1;
    if (isalpha(c) || (c=='*') || (notyet && strchr(onechars , c))
	|| ((c=='0') && !notyet && cmd[-1]=='A')) {
      *cmd++ = c;
      notyet = 0;
      if (!strchr(onechars, c)) continue;
      onecom = 1;
    }
    *cmd = 0;
    if (!onecom && (c!=' ')) ungetc(c, file);
    return 0;
  }
}


void addtobra(char *a, char *bra) {
  char my[2048];

  strcpy(my, a);
  strcat(my, bra);
  strcpy(bra, my);
}


int dobeg(FILE *in, FILE *out) {
  char comm[256];

  getcom(in, comm);
  skip(in, "}");
/*  printf("begin{%s}\n", comm);*/

  if (!*comm) { /* begin document */
    intbeg(in, out);
    return 0;
  }
  if (!strcmp(comm, "verbatim")) {
    fprintf(out, "<pre>");
    copy(in, out, SLAEND);
    fprintf(out, "</pre>\n");
    return 0;
  }
  if (!strcmp(comm, "itemize")) {
    fprintf(out, "<ul>\n");
    intbeg(in, out);
    fprintf(out, "</ul>\n");
    return 0;
  }
  if (!strcmp(comm, "thebibliography")) {
    skip(in,"{thebibliography}");
    return -1;
  }
  fprintf(out, "\\begin{%s}\n", comm);
  intbeg(in, out);
  fprintf(out, "\\end{%s}\n", comm);
  return 0;
} 


int docom(FILE *in, FILE *out, char *closebra, int insec) {
  char comm[256];
  char mystr[2048];
  footnote_t ftn;
  
  getcom(in, comm);
  printf("doing comm %s\n", comm);
  if (!strcmp(comm, "bf")) {
    fprintf(out, "<b>");
    addtobra("</b>", closebra);
    return 0;
  }
  if (!strcmp(comm, "")) {
    fprintf(out, " ");
    return 0;
  }
  if (!strcmp(comm, " ")) {
    fprintf(out, " ");
    return 0;
  }
  if (!strcmp(comm, "_")) {
    fprintf(out, "_");
    return 0;
  }
  if (!strcmp(comm, "&")) {
    fprintf(out, "&amp;");
    return 0;
  }
  if (!strcmp(comm, "\\")) {
    if (intab) fprintf(out, "</tr>");
    fprintf(out, "\n");
    if (intab) fprintf(out, "<tr><td>");
    if (intabtt) fprintf(out, "<tt>");
    return 0;
  }
  if (!strcmp(comm, "tt")) {
    fprintf(out, "<tt>");
    addtobra("</tt>", closebra);
    return 0;
  }
  if (!strcmp(comm, "em")) {
    fprintf(out, "<i>");
    addtobra("</i>", closebra);
    return 0;
  }
  if (!strcmp(comm, "it")) {
    fprintf(out, "<i>");
    addtobra("</i>", closebra);
    return 0;
  }
  if (!strcmp(comm, "item")) {
    fprintf(out, "<li>");
    return 0;
  }
  if (!strcmp(comm, "aob")) {
    fprintf(out, "Athapascan-0");
    return 0;
  }
  if (!strcmp(comm, "aof")) {
    fprintf(out, "Athapascan-0 Formats");
    return 0;
  }
  if (!strcmp(comm, "Aoe")) {
    fprintf(out, "<tt>A0Err...<td>Some error occurred.</tr><tr><td>");
    return 0;
  }
  if (!strcmp(comm, "akernel")) {
    fprintf(out, "aKernel");
    return 0;
  }
  if (!strcmp(comm, "begin")) {
    int r;

    skip(in, "{");
    r = dobeg(in, out);
    skip(in, "}");
    return r;
  }
  if (!strcmp(comm, "end")) {
/*    printf("end{}\n");*/
/*    skip(in, "}");*/
    return -1;
  }
  if (!strcmp(comm, "footnote")) {
    FILE *null;
    skip(in, "{");
    null = fopen("/dev/null", "w");
    fprintf(out, "<sup><font size=-2>%d</font></sup>\n",
		addfootnote(in));
    intbra(in, null);
    fclose(null);
    return 0;
  }
  if (!strcmp(comm, "cite")) {
    skip(in, "}");
    return 0;
  }
  if (!strcmp(comm, "today")) {
    char str[40];
    time_t t;

    time(&t);
    strftime(str, 40, "%b %d, %Y",localtime(&t));
    fprintf(out, "%s", str);
    return 0;
  }
  if (!strcmp(comm, "timeofday")) {
    char str[40];
    time_t t;

    time(&t);
    strftime(str, 40, "%H:%M", localtime(&t));
    fprintf(out, "%s", str);
    return 0;
  }
  if (!strcmp(comm, "label")) {
    skip(in, "}");
    return 0;
  }
  if (!strcmp(comm, "A0VERSION")) {
    fprintf(out, "%s", version);
    return 0;
  }
  if (!strcmp(comm, "ref")) {
    skip(in, "}");
    return 0;
  }
  if (!strcmp(comm, "htmllink")) {
    skip(in, "{");
    fprintf(out, "<a href=\"");
    intbra(in, out);
    fprintf(out, "\">");
    skip(in, "{");
    intbra(in, out);
    fprintf(out, "</a>\n");
    return 0;
  }
  if (!strcmp(comm, "reffunc")) {
    char secname[80];
    char funcname[40];

    skip(in, "{");
    getto(in, "}", funcname);
    funcname[strlen(funcname)-1] = 0;
    fprintf(out, "<a href=\"%s-%s.html\"><tt>%s</tt></a>",
		reffile, funcname, funcname);
    return 0;
  }
  if (!strcmp(comm, "reffuncfile")) {
    char secname[80];
    char funcname[40];
    char filename[40];

    skip(in, "{");
    getto(in, "}", funcname);
    funcname[strlen(funcname)-1] = 0;
    skip(in, "{");
    getto(in, "}", filename);
    filename[strlen(filename)-1] = 0;
    fprintf(out, "<a href=\"%s-%s.html\"><tt>%s</tt></a>",
		filename, funcname, funcname);
    return 0;
  }
  if (!strcmp(comm, "htmlreffile")) {
    skip(in, "{");
    getto(in, "}", reffile);
    reffile[strlen(reffile)-1] = 0;
    return 0;
  }
  if (!strcmp(comm, "html")) {
    int h;

    skip(in, "{");
    h = html;
    html = 1;
    intbra(in, out);
    fprintf(out, "\n");
    html = h;
    return 0;
  }
  if (!strcmp(comm, "htmlendsec")) {
    if (insec) return -1;
    return 0;
  }
  if (!strncmp(comm, "section", 7)) {
    fpos_t pos;
    char secname[80];
    FILE *secfile;

    if (insec) return -1;

    skip(in, "{");
    fgetpos(in, &pos);
    sprintf(secname, "%s-%d.html", outname, ++seccount);
 
    if (comm[7] == '*') {
      fprintf(out, "\n<h2><a href=\"%s\">", secname);
    }else{
      fprintf(out, "\n<h2><a href=\"%s\">%d. ", secname, ++ section);
      subsection = 0;
    }
    intbra(in, out);
    fprintf(out, "</a></h2>\n\n");

    pushfootnote(&ftn);
    secfile = fopen(secname, "w");
    fprintf(secfile, "<html><head><title>");
    fsetpos(in, &pos);
    intbra(in, secfile);
    fprintf(secfile, "</title></head>\n<body>");
    if (comm[7] == '*') {
      fprintf(secfile, "\n<h1>");
    }else{
      fprintf(secfile, "\n<h1>%d. ", section);
    }
    fsetpos(in, &pos);
    intbra(in, secfile);
    fprintf(secfile, "</h1>\n\n");
    intsec(in, secfile, closebra, 1);
    fsetpos(in, &lastcomm);
    dumpfootnotes(in, secfile);
    fprintf(secfile, "</body></html>\n");
    fclose(secfile);
    return 0;
  }
  if (!strcmp(comm, "functitle")) {
    fpos_t pos;
    char secname[80];
    char funcname[40];
    FILE *secfile;

    if (insec==2) return -1;

    skip(in, "{");
    fgetpos(in, &pos);
    getto(in, "}", funcname);
    funcname[strlen(funcname)-1] = 0;
    sprintf(secname, "%s-%s.html", outname, funcname);
 
    fprintf(out, "\n<h2><a href=\"%s\">", secname);
    fsetpos(in, &pos);
    intbra(in, out);
    fprintf(out, "</a></h2>\n\n");

    pushfootnote(&ftn);
    secfile = fopen(secname, "w");
    fprintf(secfile, "<html><head><title>");
    fsetpos(in, &pos);
    intbra(in, secfile);
    fprintf(secfile, "</title></head>\n<body>");
    fprintf(secfile, "\n<h1>");
    fsetpos(in, &pos);
    intbra(in, secfile);
    fprintf(secfile, "</h1>\n\n<p><b>");
    skip(in, "{");
    intbra(in, secfile);
    fprintf(secfile, ".</b></p>\n");
    intsec(in, secfile, closebra, 2);
    fsetpos(in, &lastcomm);
    dumpfootnotes(in, secfile);
    fprintf(secfile, "</body></html>\n");
    fclose(secfile);
    return 0;
  }
  if (!strcmp(comm, "htmlend")) {
    return -insec;
  }
  if (!strcmp(comm, "funcsyntax")) {
    int it, itt;

    skip(in, "{");
    fprintf(out, "\n<br><h2>Syntax</h2>\n\n<table>\n<tr><td><tt>");
    it = intab; itt = intabtt;
    intab = 1; intabtt = 1;
    intbra(in, out);
    fprintf(out, "</tr>\n</table>\n");
    intab = it; intabtt = itt;
    return 0;
  }
  if (!strcmp(comm, "funcargs")) {
    int it;

    skip(in, "{");
    fprintf(out, "\n<br><h2>Arguments</h2>\n\n<table border>\n<tr><td>");
    fprintf(out, "<b>Name<td><b>rd/wr<td><b>Description</tr>\n<tr><td>");
    it = intab;
    intab = 1;
    intbra(in, out);
    fprintf(out, "</tr>\n</table>\n");
    intab = it;
    return 0;
  }
  if (!strcmp(comm, "funcdescr")) {
    int it, itt;

    skip(in, "{");
    fprintf(out, "\n<h2>Description</h2>\n\n<p>");
    intbra(in, out);
    fprintf(out, "\n\n");
    return 0;
  }
  if (!strcmp(comm, "funcreturn")) {
    int it;

    skip(in, "{");
    fprintf(out, "\n<br><h2>Return Values</h2>\n\n"
    	"If an error condition occurs, it returns the error code, "
    	"otherwise it returns <tt>A0ErrOk</tt>. Possible values are "
    	"as follows:\n\n<table border>\n<tr><td>");
    fprintf(out, "<b>Error Code<td><b>Description</tr>\n<tr><td>");
    it = intab;
    intab = 1;
    intbra(in, out);
    fprintf(out, "<tt>A0ErrOk<td>Successful completion.</tr>\n"
    		"</table>\n");
    intab = it;
    return 0;
  }
  if (!strcmp(comm, "funcresult")) {
    int it;

    skip(in, "{");
    fprintf(out, "\n<p>On return of this function, the variable"
		" pointed by\n<tt>");
    intbra(in, out);
    fprintf(out, "</tt> contains \n");
    skip(in, "{");
    intbra(in, out);
    fprintf(out, ".</p>\n\n");
    intab = it;
    return 0;
  }
  if (!strcmp(comm, "seealso")) {
    char funcname[40];

    skip(in, "{");
    fprintf(out, "\n<h2>See Also</h2>\n\n<p>");
    while (!gettokenbra(in, funcname)) {
      fprintf(out, "<tt><a href=\"%s-%s.html\">%s</a> </tt>\n",
		outname, funcname, funcname);
    }
    return 0;
  }
  if (!strcmp(comm, "seealsofile")) {
    char funcname[40];
    char filename[80];

    skip(in, "{");
    getto(in, "}", filename);
    filename[strlen(filename)-1] = 0;
    skip(in, "{");
    while (!gettokenbra(in, funcname)) {
      fprintf(out, "<tt><a href=\"%s-%s.html\">%s</a> </tt>\n",
		filename, funcname, funcname);
    }
    return 0;
  }
  if (!strncmp(comm, "subsection", 10)) {
    if (comm[10] == '*') {
      fprintf(out, "\n<h2>");
    }else{
      fprintf(out, "\n<h2>%d.%d. ", section, ++ subsection);
    }
    skip(in, "{");
    intbra(in, out);
    fprintf(out, "</h2>\n\n");
    return 0;
  }
  if (!strcmp(comm, "pagebreak")) {
    fprintf(out, "<hr>\n");
    return 0;
  }
  if (!strcmp(comm, "tableofcontents")) {
    return 0;
  }
  if (!strcmp(comm, "maketitle")) {
    return 0;
  }
  if (!strcmp(comm, "abstract")) {
    fprintf(out, "<em><p>\n");
    skip(in, "{");
    intbra(in, out);
    fprintf(out, "</em><p>\n");
    return 0;
  }
  fprintf(out, "\\%s(?)", comm);
}



void intsec(FILE *in, FILE *out, char *closebra, int insec)  {

  while (1) {
    switch (copy(in, out, ALLDELIM)) {
    case WHITEL:
      fprintf(out, "\n\n<p>");
      break;
    case SLASH:
      if (docom(in, out, closebra, insec)) return;
      break;
    case OPENBRA:
      intbra(in, out);
      break;
    }
    if (feof(in)) return;
  }
}


void intbra(FILE *in, FILE *out)  {
  char closebra[2048];

  *closebra = 0;
  while (1) {
    switch (copy(in, out, ALLDELIM)) {
    case WHITEL:
      fprintf(out, "\n\n<p>");
      break;
    case SLASH:
      docom(in, out, closebra, 0);
      break;
    case OPENBRA:
      intbra(in, out);
      break;
    case CLOSEBRA:
      fprintf(out, closebra);
      return;
    }
    if (feof(in)) return;
  }
}


void intbeg(FILE *in, FILE *out)  {
  char closebra[2048];

  *closebra = 0;
  while (1) {
    switch (copy(in, out, ALLDELIM)) {
    case WHITEL:
      fprintf(out, "\n\n<p>");
      break;
    case SLASH:
      if (docom(in, out, closebra, 0)) return;
      break;
    case OPENBRA:
      intbra(in, out);
      break;
    }
    if (feof(in)) return;
  }
}


int main(int argc, char *argv[]) {
  char outhtml[80];
  FILE *out;
  FILE *in;
  int c;
  char *tit;
  footnote_t ftn;

  if (argc != 4) {
    if (argc != 3) {
      fprintf(stderr, "usage: %s: namein.tex nameout [version]\n", argv[0]);
      exit(1);
    }
    else version = "unknown";
  }
  version = argv[3];

  strcpy(outname, argv[2]);
  strcpy(outhtml, outname);
  strcat(outhtml, ".html");

  out = fopen(outhtml, "w");
  in = fopen(argv[1], "r");

  pushfootnote(&ftn);

  skip(in, "begin{document");
  dobeg(in, out);
  dumpfootnotes(in, out);
  fclose(out);
  return 0;
}
