/*
 *
 * a0fwrite.h : a0 write functions header
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * Feb 16, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0FWRITE_H
#define _A0FWRITE_H

#include <ath0.h>
#include "a0fuser.h"
#include "a0fmem.h"

/****************types********************/
/****************variables********************/
/****************functions********************/


#define _a0IFWrite(rgn, r, f, a, c) \
	_a0IFWritePart(rgn, 0, (rgn)->size, r, f, a, c)

#define _a0FWrite(rgn, r, f, a, c) \
	_a0FWritePart(rgn, 0, (rgn)->size, r, f, a, c)

extern a0tError _a0IFWritePart(a0tDMARegion *region, int start, int size,
			a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0FWritePart(a0tDMARegion *region, int start, int size,
			a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);


#ifdef A0F_SOURCE
/****************************************************************************
		Included only for compiling the lib
****************************************************************************/


extern a0tError _a0ReplyWrite(a0tMemRequest *answer);


#endif /* A0F_SOURCE */

#endif /* _A0FWRITE_H */
