/*
 *
 * akInfo.h : Information about thread time usage
 *
 * by Alexandre Carissimi
 * Apache Project, IMAG, Grenoble, France
 * Feb 2, 1999
 *
 */
 
#ifndef _AKINFO_H
#define _AKINFO_H


#define		MAIN_TYPE	0
#define		DAEMON_TYPE	1
#define		URGENT_TYPE	2
#define		SERVICE_TYPE	3
#define		USER_TYPE	4

#define		MAXTHREADS	128

/***********************
   DATATYPE DEFINITIONS
 ***********************/
 
typedef struct TimeStat {
        int	Type;
	double	ElapsedTime;
	double	UserTime;
	double	SystemTime;
	double	OSTime;
	double	LockTime;
	double	SlpTime;
	double	WaitTime;
	double	StopTime;
	unsigned long Vctx;
	unsigned long Ictx;
}TimeStat_t;


/*********************************************************************
                         PROTOTYPES
 *********************************************************************/
 
void	akInfo(int );
void	akPrint(int , char *);

#endif  /*_AKINFO_H*/
