#include <a0b.h>
#include <stdio.h>

int main(int argc, char *argv[]) {

  a0tPort port;
  int i, ready;
  int out[100], in[100];
  a0tRequest outreq[100], inreq[100];
  a0tRequest *reqtab[200];

  a0Init(&argc, &argv);
  a0NewPort(&port, 1, A0GlobalCreation);
  a0InitCommit();

  if (a0NodeCount > 100) {
    printf("Run at most with 100 nodes!\n");
    a0Abort(1);
  }

  for (i=0; i<a0NodeCount; i++) {
    out[i] = 1000 + a0SelfNode;
    in[i] = 0;
  }

  for (i=0; i<a0NodeCount; i++) {
    a0ISend(&port, i, 0, outreq+i, a0_INT, out+i, 1);
    a0IReceive(&port, i, 0, inreq+i, a0_INT, in+i, 1);
  }

  for (i=0; i<a0NodeCount; i++) {
    reqtab[i] = outreq + i;
    reqtab[i+a0NodeCount] = inreq + i;
  }
  
  for (i=0; i<(a0NodeCount*2); i++) {
    a0WaitAnyRequest(reqtab, a0NodeCount*2, &ready);
    reqtab[ready] = NULL;
  }
/*
  for (i=0; i<(a0NodeCount*2);) {
    a0TestAnyRequest(reqtab, a0NodeCount*2, &ready);
    if (ready != A0NoneCompleted) {
      i++;
      reqtab[ready] = NULL;
    }
  }
*/
  for (i=0; i<a0NodeCount; i++)
    printf("node %d got %d from node %d\n", a0SelfNode, in[i], i);

  a0Terminate();
}
