/***********************/
/* sample ping program */
/***********************/

#include <a0b.h>
#include <stdio.h>

const int TailleData = 10000;
const int NbSend = 10;
const int Tag= 1;


int main(int argc, char* argv[])
{
  int me, nbp;
  double data[10000];
  int tailletransfert;
  double temps;

  a0tPort gport;
  a0tRequest req;

  int i,j;


  a0Init(&argc, &argv);
  a0NewPort(&gport,Tag+1, FALSE); /*// creation d'un port commun*/
  a0InitCommit(); /*// effet de barriere*/


  nbp = a0NodeCount;
  me = a0SelfNode;

  if (me ==0)
   {
    printf("Starting %d ping pongs\n",NbSend);
    temps = MPI_Wtime();
   }

  for(i=0; i< NbSend; i++)
    {
      printf("Sender %d Receiver %d Size %d \n", me, i, (TailleData/NbSend)*i * sizeof(double));
      if (me == 0)
	{for(j=1; j<nbp; j++)
	  if (a0Send(&gport, j, Tag, &req, a0_DOUBLE, data, (TailleData/NbSend)*i) != A0ErrOk)
	    printf("pb send\n");
	}
      else 
	a0Receive(&gport, 0, Tag, &req, a0_DOUBLE, data, (TailleData/NbSend)*i);
      if (me == 0)
	for(j=1; j<nbp; j++)
	  a0Receive(&gport, j, Tag, &req, a0_DOUBLE, data, (TailleData/NbSend)*i);
      else
	a0Send(&gport, 0, Tag, &req, a0_DOUBLE, data, (TailleData/NbSend)*i);
    }
  if (me == 0)
    {
      temps = MPI_Wtime() - temps;
      printf("Communication time:%f\n", temps);
    }

  a0DisposePort(&gport);
  a0Terminate();
  if (me==0) printf("End of program\n");
}

