#ifndef A0_PERF_DECODE_H

#define A0_PERF_DECODE_H

#include "a0semap.h"
#include "a0_perf_trace_buffer.h"

extern char * _a0_perf_decode_buffer (char *buf);
extern int a0_perf_decode_event (char **buffer);
extern void a0_perf_init_min_max ();
extern void a0_perf_write_min_max ();
extern int read_adjust_file ();


typedef struct {
char *file_name;
int is_processed;
double slope;	/* global clock adjust parameters */
double offset;
} file_check;

extern int nb_files;
extern int check_nb_files;
extern double time_reference;
extern int time_reference_is_defined;
extern FILE *adjust_input_file;
extern FILE *fout,*fin;

extern file_check check_tab [];

#define MAX_NODE_NUMBER 10000

#define a0_perf_UrgentDaemon	-1
#define a0_perf_RemoteDaemon	-2

#define event_a0SetLimits	0
#define event_a0Abort	2
#define event_a0BroadcastCondition	4
#define event_a0ClearBuffer	6
#define event_a0DetachSlave	8
#define event_a0DisposeBuffer	10
#define event_a0DisposeCondition 	12
#define event_a0DisposeMutex	14
#define event_a0DisposePort	16
#define event_a0DisposeSemaphore	18
#define event_a0ExitThread	20
#define event_a0GetRequestData	24
#define event_a0GetThreadPriority	26
#define event_a0GetThreadScheduling	28
#define event_a0IReceive	30
#define event_a0IStartRemoteUrgent	32
#define event_a0IStartRemoteThread	34
#define event_a0ISend		36
#define event_a0ISendBuffer	38
#define event_a0Init	40
#define event_a0InitCommit	42
#define event_a0IReceiveBuffer	44
#define event_a0JoinSlave	46
#define event_a0LockMutex	48
#define event_a0NewBuffer	50
#define event_a0NewCondition	52
#define event_a0NewMutex	54
#define event_a0NewPort	56
#define event_a0NewService	58
#define event_a0NewSemaphore	60
#define event_a0NewSlave	62
#define event_a0PSemaphore	64
#define event_a0Pack		66
#define event_a0Probe		68
#define event_a0Receive	70
#define event_a0ReceiveBuffer	72
#define event_a0StartRemoteUrgent	74
#define event_a0StartRemoteThread	76
#define event_a0Send	78
#define event_a0SendBuffer	80
#define event_a0SetDefaultPriority	82
#define event_a0SetDefaultStack	84
#define event_a0SetThreadPriority	86
#define event_a0SetThreadScheduling	88
#define event_a0SignalCondition	90
#define event_a0Terminate	92
#define event_a0TestRequest	94
#define event_a0TimedWaitCondition	96
#define event_a0TryPSemaphore	98
#define event_a0UnlockMutex	100
#define event_a0Unpack	102
#define event_a0UserEvent	104
#define event_a0VSemaphore	106
#define event_a0WaitCondition	108
#define event_a0WaitRequest	110
#define event_a0YieldThread	112
#define event_a0IProbe		122
#define event_a0IReceiveAny	124
#define event_a0IReceiveBufferAny	126
#define event_a0NewContext	128
#define event_a0GetSelfContext	130
#define event_a0SetSelfContext	132
#define event_a0WaitAnyRequest	134
#define event_a0TestAnyRequest	136

#define event_a0IFPut	140
#define event_a0FPut	142
#define event_a0IFGet	144
#define event_a0FGet	146
#define event_a0Flush	148
#define event_a0NewPipe	150
#define event_a0DisposePipe	152
#define event_a0UseFormats	154
#define event_a0IFSend	156
#define event_a0FSend		158
#define event_a0IFReceive	160
#define event_a0FReceive	162
#define event_a0FPack		164
#define event_a0FUnpack	166
#define event_a0NewDmaRegion	168
#define event_a0IFReadPart	170
#define event_a0FReadPart	172
#define event_a0IFRead	174
#define event_a0FRead		176
#define event_a0IFWritePart	178
#define event_a0FWritePart	180
#define event_a0IFWrite	182
#define event_a0FWrite	184
#define event_a0IFCopyPart	186
#define event_a0FCopyPart	188
#define event_a0IFCopy	190
#define event_a0FCopy		192
#define event_a0IFReceiveAny	194



#define a0_perf_BeginUrgentService	200
#define a0_perf_EndOfUserThread	202
#define a0_perf_EndUrgentService	204
#define a0_perf_IdentifyEvent	206
#define a0_perf_IdentifyFile	208
#define a0_perf_InitUserThreadTraceBuffer	210
#define a0_perf_BeginThreadService	212
#define a0_perf_WaitTraceBuffer	214
#define a0_perf_CompletedSend	216
#define a0_perf_CompletedRecv	218
#define a0_perf_CompletedProbe	220
#define a0_perf_CompletedOther	222
#define a0_perf_IdentifyFormat 224

#define a0_perf_InitFRead		230
#define a0_perf_InitFWrite		231
#define a0_perf_InitFCopy		232
#define a0_perf_InitFLock		233
#define a0_perf_InitFLockRead		234
#define a0_perf_InitFUnlock		235
#define a0_perf_InitFUnlockWrite	236
#define a0_perf_WriteCopy		237
#define a0_perf_ReplyRead		238
#define a0_perf_ReplyWrite		239

#define event_a0FGetFormatSize	250
#define event_a0FGetFormatOffset	252
#define event_a0FDisposeFormat	254
#define event_a0NewMapFormat		256
#define event_a0SetMapField		258
#define event_a0NewFunctionFormat	260

#define event_a0SetLockRead		262
#define event_a0SetUnlockWrite		264
#define event_a0SetLockDMARegion	266
#define event_a0SetLockDMARegionPart	268
#define event_a0Lock			270
#define event_a0ILock			272
#define event_a0Unlock			274
#define event_a0IUnlock			276
#define event_a0IFReadPartLock		278
#define event_a0FReadPartLock		280
#define event_a0FWriteUnlock		282
#define event_a0IFWriteUnlock		284

#endif
