/*****************************************************************************/
/* File a0_perf_event_codes.h                                                */
/* Ph. Waille  05/07/96                                                      */
/*****************************************************************************/

#ifndef PERF_EVENT_CODE_H
#define PERF_EVENT_CODE_H

/* Event record identifiers are bytes */

#define A0_PERF_RECORD_ID_ABORT 		1
#define A0_PERF_RECORD_ID_BROADCASTCONDITION 	2
#define A0_PERF_RECORD_ID_DISPOSEPORT		3
#define A0_PERF_RECORD_ID_DETACHSLAVE		4
#define A0_PERF_RECORD_ID_DISPOSEBUFFER		5
#define A0_PERF_RECORD_ID_DISPOSECONDITION	6
#define A0_PERF_RECORD_ID_DISPOSEMUTEX		7
#define A0_PERF_RECORD_ID_DISPOSESEMAPHORE	8
#define A0_PERF_RECORD_ID_EXITTHREAD		9
#define A0_PERF_RECORD_ID_GETREQUESTINFO	10
#define A0_PERF_RECORD_ID_GETTHREADPRIORITY	11
#define A0_PERF_RECORD_ID_GETTHREADSCHEDULING	12
#define A0_PERF_RECORD_ID_INIT			13
#define A0_PERF_RECORD_ID_INITCOMMIT		14
#define A0_PERF_RECORD_ID_JOINSLAVE		15
#define A0_PERF_RECORD_ID_LOCKMUTEX		16
#define A0_PERF_RECORD_ID_NEWBUFFER		17
#define A0_PERF_RECORD_ID_NEWCONDITION		18
#define A0_PERF_RECORD_ID_NEWMUTEX		19
#define A0_PERF_RECORD_ID_NEWPORT		20
#define A0_PERF_RECORD_ID_NEWSEMAPHORE		21
#define A0_PERF_RECORD_ID_NEWRRSERVICE		22
#define A0_PERF_RECORD_ID_NEWSLAVE		24
#define A0_PERF_RECORD_ID_PACK			25
#define A0_PERF_RECORD_ID_PSEMAPHORE		26
#define A0_PERF_RECORD_ID_RECEIVE		27
#define A0_PERF_RECORD_ID_RECEIVEBUFFER		28
#define A0_PERF_RECORD_ID_REMOTEREQUEST		29
#define A0_PERF_RECORD_ID_REMOTETHREADCREATE	30
#define A0_PERF_RECORD_ID_SEND			31
#define A0_PERF_RECORD_ID_SENDBUFFER		32
#define A0_PERF_RECORD_ID_SETDEFAULTPRIORITY	33
#define A0_PERF_RECORD_ID_SETDEFAULTSCHEDULING	34
#define A0_PERF_RECORD_ID_SETDEFAULTSTACK	35
#define A0_PERF_RECORD_ID_SETTHREADPRIORITY	36
#define A0_PERF_RECORD_ID_SETTHREADSCHEDULING	37
#define A0_PERF_RECORD_ID_SIGNALCONDITION	38
#define A0_PERF_RECORD_ID_TERMINATE		39
#define A0_PERF_RECORD_ID_TESTREQUEST		40
#define A0_PERF_RECORD_ID_TIMEDWAITCONDITION	41
#define A0_PERF_RECORD_ID_TRYPSEMAPHORE		42
#define A0_PERF_RECORD_ID_UNLOCKMUTEX		43
#define A0_PERF_RECORD_ID_UNPACK		44
#define A0_PERF_RECORD_ID_VSEMAPHORE		45
#define A0_PERF_RECORD_ID_WAITCONDITION		46
#define A0_PERF_RECORD_ID_WAITREQUEST		47
#define A0_PERF_RECORD_ID_YIELDTHREAD		48
#define A0_PERF_RECORD_ID_CLEAR_BUFFER		49
#define A0_PERF_RECORD_ID_ISEND			50
#define A0_PERF_RECORD_ID_ISENDBUFFER		51
#define A0_PERF_RECORD_ID_IRECEIVE		52
#define A0_PERF_RECORD_ID_IRECEIVEBUFFER	53
#define A0_PERF_RECORD_ID_IREMOTEREQUEST        54
#define A0_PERF_RECORD_ID_IREMOTETHREADCREATE   55 
#define A0_PERF_RECORD_ID_PROBE			56
#define A0_PERF_RECORD_ID_IPROBE		57
#define A0_PERF_RECORD_ID_IRECEIVEANY		58
#define A0_PERF_RECORD_ID_IRECEIVEBUFFERANY	59
#define A0_PERF_RECORD_ID_NEWCONTEXT		60
#define A0_PERF_RECORD_ID_GETSELFCONTEXT	61
#define A0_PERF_RECORD_ID_SETSELFCONTEXT	62
#define A0_PERF_RECORD_ID_WAITANYREQUEST	63
#define A0_PERF_RECORD_ID_TESTANYREQUEST	64

#define A0_PERF_RECORD_ID_IFRECEIVEANY		69
#define A0_PERF_RECORD_ID_IFPUT			70
#define A0_PERF_RECORD_ID_FPUT			71
#define A0_PERF_RECORD_ID_IFGET			72
#define A0_PERF_RECORD_ID_FGET			73
#define A0_PERF_RECORD_ID_FLUSH			74
#define A0_PERF_RECORD_ID_NEWPIPE		75
#define A0_PERF_RECORD_ID_DISPOSEPIPE		76
#define A0_PERF_RECORD_ID_USEFORMATS		77
#define A0_PERF_RECORD_ID_IFSEND		78
#define A0_PERF_RECORD_ID_FSEND			79
#define A0_PERF_RECORD_ID_IFRECEIVE		80
#define A0_PERF_RECORD_ID_FRECEIVE		81
#define A0_PERF_RECORD_ID_FPACK			82
#define A0_PERF_RECORD_ID_FUNPACK		83
#define A0_PERF_RECORD_ID_NEWDMAREGION		84
#define A0_PERF_RECORD_ID_IFREADPART		85
#define A0_PERF_RECORD_ID_FREADPART		86
#define A0_PERF_RECORD_ID_IFREAD		87
#define A0_PERF_RECORD_ID_FREAD			88
#define A0_PERF_RECORD_ID_IFWRITEPART		89
#define A0_PERF_RECORD_ID_FWRITEPART		90
#define A0_PERF_RECORD_ID_IFWRITE		91
#define A0_PERF_RECORD_ID_FWRITE		92
#define A0_PERF_RECORD_ID_IFCOPYPART		93
#define A0_PERF_RECORD_ID_FCOPYPART		94
#define A0_PERF_RECORD_ID_IFCOPY		95
#define A0_PERF_RECORD_ID_FCOPY			96

#define A0_PERF_RECORD_ID_IDENTIFY_FILE		97
#define A0_PERF_RECORD_ID_IDENTIFY_EVENT	98
#define A0_PERF_RECORD_ID_USER_EVENT		99
#define A0_PERF_RECORD_ID_INIT_TRACE_BUFFER	100
#define A0_PERF_RECORD_ID_END_OF_USER_THREAD	101
#define A0_PERF_RECORD_ID_START_REMOTE_SERVICE	102
#define A0_PERF_RECORD_ID_BEGIN_REMOTE_REQUEST	103
#define A0_PERF_RECORD_ID_END_REMOTE_REQUEST	104
#define A0_PERF_RECORD_ID_WAIT_BUFFER		105
#define A0_PERF_RECORD_ID_COMPLETED_SEND	106
#define A0_PERF_RECORD_ID_COMPLETED_RECV	107
#define A0_PERF_RECORD_ID_COMPLETED_PROBE	108
#define A0_PERF_RECORD_ID_COMPLETED_OTHER	109
#define A0_PERF_RECORD_ID_IDENTIFY_FORMAT	110

#define A0_PERF_RECORD_ID_SETLOCKREAD		111
#define A0_PERF_RECORD_ID_SETUNLOCKWRITE	112
#define A0_PERF_RECORD_ID_SETLOCKDMAREGION	113
#define A0_PERF_RECORD_ID_SETLOCKDMAREGIONPART	114
#define A0_PERF_RECORD_ID_LOCK			115
#define A0_PERF_RECORD_ID_UNLOCK		116
#define A0_PERF_RECORD_ID_ILOCK			117
#define A0_PERF_RECORD_ID_IUNLOCK		118
#define A0_PERF_RECORD_ID_IFREADPARTLOCK	119
#define A0_PERF_RECORD_ID_FREADPARTLOCK		120
#define A0_PERF_RECORD_ID_IFWRITEUNLOCK		121
#define A0_PERF_RECORD_ID_FWRITEUNLOCK		122


#define A0_PERF_RECORD_ID_GETFORMATSIZE		150
#define A0_PERF_RECORD_ID_GETFORMATOFFSET	151
#define A0_PERF_RECORD_ID_DISPOSEFORMAT		152
#define A0_PERF_RECORD_ID_NEWMAPFORMAT		153
#define A0_PERF_RECORD_ID_SETMAPFIELD		154
#define A0_PERF_RECORD_ID_NEWFUNCTIONFORMAT	155

#define A0_PERF_RECORD_ID_INIT_FREAD		160
#define A0_PERF_RECORD_ID_INIT_FWRITE		161
#define A0_PERF_RECORD_ID_INIT_FCOPY		162
#define A0_PERF_RECORD_ID_INIT_FLOCK		163
#define A0_PERF_RECORD_ID_INIT_FLOCKREAD	164
#define A0_PERF_RECORD_ID_INIT_FUNLOCK		165
#define A0_PERF_RECORD_ID_INIT_FUNLOCKWRITE	166
#define A0_PERF_RECORD_ID_WRITECOPY	167
#define A0_PERF_RECORD_ID_REPLYREAD	168
#define A0_PERF_RECORD_ID_REPLYWRITE	169


#endif
