#ifndef PERF_FMEM_H
#define PERF_FMEM_H

#include "a0fread.h"
#include "a0fwrite.h"
#include "a0fcopy.h"



extern a0tError _a0_perf_NewDMARegion(a0tDMARegion *region,
                        a0tFormat *formatp, void *pointer, int size);

extern a0tError _a0_perf_IFReadPart(a0tDMARegion *region, int start, int size,
			a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0_perf_FReadPart(a0tDMARegion *region, int start, int size,
			a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0_perf_IFRead(a0tDMARegion *region, a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0_perf_FRead(a0tDMARegion *region, a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0_perf_IFWritePart(a0tDMARegion *region, int start, int size,
			a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0_perf_FWritePart(a0tDMARegion *region, int start, int size,
			a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0_perf_IFWrite(a0tDMARegion *region, a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0_perf_FWrite(a0tDMARegion *region, a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0_perf_IFCopyPart(a0tDMARegion *region1, int start1,
			int size1, a0tRequest *reqp,
			a0tDMARegion *region2, int start2, int size2);

extern a0tError _a0_perf_FCopyPart(a0tDMARegion *region1, int start1, int size1,
			a0tRequest *reqp,
			a0tDMARegion *region2, int start2, int size2);

extern a0tError _a0_perf_IFCopy(a0tDMARegion *region1, 
			a0tRequest *reqp,
			a0tDMARegion *region2);

extern a0tError _a0_perf_FCopy(a0tDMARegion *region1,
			a0tRequest *reqp,
			a0tDMARegion *region2);

#endif
