/*
 *
 * a0_perf_pt2pt.h 
 *
 * by Philippe Waille
 * Apache Project, IMAG, Grenoble, France
 * July 16, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0_PERF_PT2PT_H
#define _A0_PERF_PT2PT_H

#include "a0mpi.h"
#include "a0pt2pt.h"
#include "a0ports.h"


extern a0tError _a0_perf_WaitRequest(a0tRequest *req);

extern a0tError _a0_perf_WaitAnyRequest(a0tRequest *reqta[],int size,
					int *which);

extern a0tError _a0_perf_TestRequest(a0tRequest *req, int *completed);

extern a0tError _a0_perf_TestAnyRequest(a0tRequest *reqta[],int size,
					int *which);

extern a0tError _a0_perf_ISendBuffer(a0tPort *port, int dest, int tag,
                                a0tRequest *request, a0tBuffer *buffer);

extern a0tError _a0_perf_SendBuffer(a0tPort *port, int dest, int tag,
                                a0tRequest *request, a0tBuffer *buffer);

extern a0tError _a0_perf_ISend(a0tPort *port, int dest, int tag,
                                a0tRequest *request, a0tDatatype datatype,
                                void *address, int count);

extern a0tError _a0_perf_Send(a0tPort *port, int dest, int tag,
                                a0tRequest *request, a0tDatatype datatype,
                                void *address, int count);

extern a0tError _a0_perf_IReceiveBuffer(a0tPort *port, int source, int tag,
                                a0tRequest *request, a0tBuffer *buffer);

extern a0tError _a0_perf_ReceiveBuffer(a0tPort *port, int source, int tag,
                                a0tRequest *request, a0tBuffer *buffer);

extern a0tError _a0_perf_IReceive(a0tPort *port, int source, int tag,
                                a0tRequest *request, a0tDatatype datatype,
                                void *address, int count);

extern a0tError _a0_perf_Receive(a0tPort *port, int source, int tag,
                                a0tRequest *request, a0tDatatype datatype,
                                void *address, int count);

extern int _a0_perf_GetRequestData(a0tRequest *request,
					a0tRequestData *data);

extern a0tError _a0_perf_Probe (a0tPort *port,int source, int tag, 
					a0tRequest *req);

extern a0tError _a0_perf_IProbe (a0tPort *port,int source, int tag, 
					a0tRequest *req);



#endif /* _A0_PERF_PT2PT_H */


