/*
 *
 * a0_perf_services.h 
 *
 *
 * by Philippe Waille
 * Apache Project, IMAG, Grenoble, France
 * July 16, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0_PERF_SERVICES_H
#define _A0_PERF_SERVICES_H


#include "a0services.h"


a0tError _a0_perf_NewService(int *Service, a0tRemoteFunction Code,
                        a0tScheduling Sched, int Prio, long StackSize);


/* executing a service on a remote node (in a separate thread) */
extern a0tError _a0_perf_StartRemoteThread(
                int node,
                int service,
                a0tScheduling sched,
                int prio,
                long stack,
		a0tRequest *requestp,
                a0tBuffer *buffer
                );

/* Do a remote request call on a remote node (no thread created there) */
extern a0tError _a0_perf_StartRemoteUrgent(
                int node,
                int service,
		a0tRequest *requestp,
                a0tBuffer *buffer
                );


/* executing a service on a remote node (in a separate thread) */
extern a0tError _a0_perf_IStartRemoteThread(
                int node,
                int service,
                a0tScheduling sched,
                int prio,
                long stack,
		a0tRequest *requestp,
                a0tBuffer *buffer
                );

/* Do a remote request call on a remote node (no thread created there) */
extern a0tError _a0_perf_IStartRemoteUrgent(
                int node,
                int service,
		a0tRequest *requestp,
                a0tBuffer *buffer
                );

#endif /* _A0_PERF_SSERVICES_H */
