/*
 *
 * a0fcopy.h : a0 copy functions header
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * Feb 16, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0FCOPY_H
#define _A0FCOPY_H

#include <ath0.h>
#include "a0fuser.h"
#include "a0fmem.h"

/****************types********************/
/****************variables********************/
/****************functions********************/


#define _a0IFCopy(rgn1, r, rgn2) \
	_a0IFCopyPart(rgn1, 0, (rgn1)->size, r, rgn2, 0, (rgn2)->size)

#define _a0FCopy(rgn1, r, rgn2) \
	_a0FCopyPart(rgn1, 0, (rgn1)->size, r, rgn2, 0, (rgn2)->size)

extern a0tError _a0IFCopyPart(a0tDMARegion *region1, int start1, int size1,
			a0tRequest *reqp,
			a0tDMARegion *region2, int start2, int size2);

extern a0tError _a0FCopyPart(a0tDMARegion *region1, int start1, int size1,
			a0tRequest *reqp,
			a0tDMARegion *region2, int start2, int size2);


#ifdef A0F_SOURCE
/****************************************************************************
		Included only for compiling the lib
****************************************************************************/

extern a0tError _a0InitCopy();

#endif /* A0F_SOURCE */

#endif /* _A0FCOPY_H */
