/*
 *
 * a0fread.h : a0 read functions header
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * Feb 16, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0FREAD_H
#define _A0FREAD_H

#include <ath0.h>
#include "a0fuser.h"
#include "a0fmem.h"

/****************types********************/
/****************variables********************/
/****************functions********************/


#define _a0IFRead(rgn, r, f, a, c) \
	_a0IFReadPart(rgn, 0, (rgn)->size, r, f, a, c)

#define _a0FRead(rgn, r, f, a, c) \
	_a0FReadPart(rgn, 0, (rgn)->size, r, f, a, c)

extern a0tError _a0IFReadPart(a0tDMARegion *region, int start, int size,
			a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);

extern a0tError _a0FReadPart(a0tDMARegion *region, int start, int size,
			a0tRequest *reqp,
			a0tFormat *formatp, void *address, int count);


#ifdef A0F_SOURCE
/****************************************************************************
		Included only for compiling the lib
****************************************************************************/


extern a0tError _a0ReplyRead(a0tMemRequest *answer);


#endif /* A0F_SOURCE */

#endif /* _A0FREAD_H */
