/*
 *
 * a0semap.h : semaphore & mutex handling functions
 *
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * Feb 21, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0SEMAP_H
#define _A0SEMAP_H


#include <akernel.h>
#include "a0error.h"


/****************defines********************/

/****************types********************/

typedef aktSemaphore	a0tSemaphore;
typedef akpthread_mutex_t	a0tMutex;
typedef akpthread_key_t	a0tContext;


/****************variables********************/

/****************functions********************/

extern a0tError _a0NewSemaphore(a0tSemaphore *semap, int value);
extern a0tError _a0DisposeSemaphore(a0tSemaphore *semap);
extern a0tError _a0PSemaphore(a0tSemaphore *semap);
extern a0tError _a0TryPSemaphore(a0tSemaphore *semap, int *success);
extern a0tError _a0VSemaphore(a0tSemaphore *semap);

extern a0tError _a0NewMutex(a0tMutex *mutex);
extern a0tError _a0DisposeMutex(a0tMutex *mutex);
extern a0tError _a0LockMutex(a0tMutex *mutex);
extern a0tError _a0UnlockMutex(a0tMutex *mutex);

extern a0tError _a0NewContext(a0tContext *contextp);
extern a0tError _a0SetSelfContext(a0tContext *contextp, void *datap);
extern a0tError _a0GetSelfContext(a0tContext *contextp, void **datapp);


#ifdef A0_SOURCE
/****************************************************************************
		Included only for compiling the lib
****************************************************************************/


#endif /* A0_SOURCE */

#endif /* _A0THREAD_H */
