/*
 *
 * akerror.h : Error handling functions
 *
 *
 * February 14rd, 1996. Ilan Ginzburg, Marcelo Pasin.
 *
 * Athapascan Kernel.
 *
 */

/* Eliminates multiple includes of this file */
#ifndef _AKERROR_H
#define _AKERROR_H

/* akernel error return codes */
#define akERROK		0
#define akERRMPISEND	(-1)
#define akERRMPIRECV	(-2)
#define akERRMPICOMM	(-3)
#define akERRNULLHANDLE	(-4)
#define akERRCANCEL	(-5)

/* akernel internal error codes */
#define akINTERNALERROR (-1000)

/* akernel internal fatal error codes */
#define akFATALERROR	(-2000)
#define akERRSEMAP	(-2001)
#define akERRDAEMON	(-2002)
#define akERRMPI	(-2003)
#define akERRMUTEXLOCK	(-2004)
#define akERRMUTEXUNLOCK (-2005)
#define akERRNOWC	(-2006)
#define akERRMUTEXINIT	(-2007)
#define akERRCONDINIT	(-2008)
#define akERRDAEMONTIMER (-2009)
#define akERRSCHED	(-2010)
#define akERRMUTEXDESTR	(-2011)
#define akERRCONDSIG	(-2012)
#define akERRCONDDESTR	(-2013)
#define akERRINVALID	(-2014)
#define akERREMPTY	(-2015)
#define akERRNOMEM	(-2016)
#define akERRUSED	(-2017)
#define akERROBSOL	(-2018)
#define akERRCONDWAIT	(-2019)
#define akERRGETCOUNT	(-2020)
#define akERRCONTEXT	(-2021)
#define akERRWRONGWC	(-2022)


#ifdef AKERNEL_SOURCE
/****************************************************************************
		Included only for compiling the kernel
****************************************************************************/


#define akError(a, b)	akErrorPrint(__FILE__, __LINE__, a, b)


/* error handling function */
extern int akErorrPrint(char *file, int line, int err, char *msg);


#endif /* AKERNEL_SOURCE */

#endif /* _AKERROR_H */
