/* a0b_nameshifts.h
 * 	 
 * Definition of the correspondace between a0 librairies names and
 * a0 user interface names.
 *
 * Library names are different from user interface names to simplify the
 * task of performance evaluation or tracers writing.
 *
 * by Ilan Ginzburg
 * Apache Project, IMAG, Grenoble, France
 * July 5, 1996
 *
 */

/* The user sees the names without the leading underscore, but the real names
 * used in athapascan library (and source code) are the ones WITH the
 * underscore.
 */

#define a0Abort			_a0Abort
#define a0ClearBuffer		_a0ClearBuffer
#define a0DetachSlave		_a0DetachSlave
#define a0DisposeBuffer		_a0DisposeBuffer
#define a0DisposeMutex		_a0DisposeMutex
#define a0DisposePort		_a0DisposePort
#define a0DisposeSemaphore	_a0DisposeSemaphore
#define a0ExitThread		_a0ExitThread
#define a0GetBufferPosition	_a0GetBufferPosition
#define a0GetPackedSize		_a0GetPackedSize
#define a0GetRequestData	_a0GetRequestData
#define a0GetSelfContext	_a0GetSelfContext
#define a0GetSelfThread		_a0GetSelfThread
#define a0GetSelfThreadPriority	_a0GetSelfThreadPriority
#define a0GetSelfThreadScheduling _a0GetSelfThreadScheduling
#define a0GetThreadPriority	_a0GetThreadPriority
#define a0GetThreadScheduling	_a0GetThreadScheduling
#define a0IProbe		_a0IProbe
#define a0IReceive		_a0IReceive
#define a0IReceiveBuffer	_a0IReceiveBuffer
#define a0ISend			_a0ISend
#define a0ISendBuffer		_a0ISendBuffer
#define a0IStartRemoteThread	_a0IStartRemoteThread
#define a0IStartRemoteUrgent	_a0IStartRemoteUrgent
#define a0Init			_a0Init
#define a0InitCommit		_a0InitCommit
#define a0JoinSlave		_a0JoinSlave
#define a0JoinThread		_a0JoinThread
#define a0LockMutex		_a0LockMutex
#define a0NewBuffer		_a0NewBuffer
#define a0NewBufferStorage	_a0NewBufferStorage
#define a0NewContext		_a0NewContext
#define a0NewMutex		_a0NewMutex
#define a0NewPort		_a0NewPort
#define a0NewSemaphore		_a0NewSemaphore
#define a0NewService		_a0NewService
#define a0NewSlave		_a0NewSlave
#define a0PSemaphore		_a0PSemaphore
#define a0Pack			_a0Pack
#define a0Probe			_a0Probe
#define a0Receive		_a0Receive
#define a0ReceiveBuffer		_a0ReceiveBuffer
#define a0Send			_a0Send
#define a0SendBuffer		_a0SendBuffer
#define a0SetBufferPosition	_a0SetBufferPosition
#define a0SetDefaultStack	_a0SetDefaultStack
#define a0SetSelfContext	_a0SetSelfContext
#define a0SetSelfThreadPriority	_a0SetSelfThreadPriority
#define a0SetSelfThreadScheduling _a0SetSelfThreadScheduling
#define a0SetThreadPriority	_a0SetThreadPriority
#define a0SetThreadScheduling	_a0SetThreadScheduling
#define a0StartRemoteThread	_a0StartRemoteThread
#define a0StartRemoteUrgent	_a0StartRemoteUrgent
#define a0Terminate		_a0Terminate
#define a0TestAnyRequest	_a0TestAnyRequest
#define a0TestRequest		_a0TestRequest
#define a0TryPSemaphore		_a0TryPSemaphore
#define a0UnlockMutex		_a0UnlockMutex
#define a0Unpack		_a0Unpack
#define a0VSemaphore		_a0VSemaphore
#define a0WaitAnyRequest	_a0WaitAnyRequest
#define a0WaitRequest		_a0WaitRequest
#define a0YieldThread		_a0YieldThread


/* going to disappear */
#define a0RemoteRequest		_a0RemoteRequest
#define a0RemoteThreadCreate	_a0RemoteThreadCreate


#define a0NewCondition 		_a0NewCondition 
#define a0DisposeCondition 	_a0DisposeCondition	
#define a0SignalCondition 	_a0SignalCondition 
#define a0BroadcastCondition 	_a0BroadcastCondition 
#define a0WaitCondition 	_a0WaitCondition 
#define a0TimedWaitCondition	_a0TimedWaitCondition	

#define	a0GetSchedPolicy	_a0GetSchedPolicy
#define	a0SetSchedPolicy	_a0SetSchedPolicy
#define	a0GetSchedPriority	_a0GetSchedPriority
#define	a0SetSchedPriority	_a0SetSchedPriority
#define	a0GetSchedScope		_a0GetSchedScope
#define	a0SetSchedScope		_a0SetSchedScope
#define	a0GetInherit		_a0GetInherit
#define	a0SetInherit		_a0SetInherit
#define a0SetStackSize		_a0SetStackSize
#define a0GetStackSize		_a0GetStackSize
#define a0SetStackAddr		_a0SetStackAddr
#define a0GetStackAddr		_a0GetStackAddr
#define	a0SetSchedParam		_a0SetSchedParam
#define	a0GetSchedParam		_a0GetSchedParam

#define a0NewNewSlave		_a0NewNewSlave

/* Empty macro defined to compile application without trace generation */

#define	a0UserEvent(a,b)

