/*
 *
 * a0_perf_buffer.h : Perf functions for the Ath0 buffers
 *
 * by Philippe Waille
 * Apache Project, IMAG, Grenoble, France
 * July 16 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0_PERF_BUFFER_H
#define _A0_PERF_BUFFER_H

#include "a0buffer.h"

extern a0tError _a0_perf_ClearBuffer (a0tBuffer *buffer);

extern a0tError _a0_perf_NewBuffer(a0tBuffer *buffer,
                                   a0tBufferType type,
                                   long size) ;

extern a0tError _a0_perf_DisposeBuffer(a0tBuffer *buffer);

extern a0tError _a0_perf_Pack(a0tBuffer *buffer, 
                              a0tDatatype datatype, 
                              void *inbuf, 
                              int incount);

extern a0tError _a0_perf_Unpack(a0tBuffer *buffer, 
                                a0tDatatype datatype, 
                                void *outbuf, 
                                int outcount);
#endif /* _A0_PERF_BUFFER_H */


