/***************************************************************************/
/* File a0_perf_init.c                                                     */
/* Philippe Waille 05/07/96                                                */
/***************************************************************************/

#include "a0init.h"
#include "a0_perf_init.h"
#include "a0_perf_event_macros.h"
#include "a0_perf_event_codes.h"
#include "a0_perf_trace_buffer.h"

a0tError _a0_perf_Init (int *argcp,char ***argvp)
{
a0_perf_begin_event_init;
/* begin event would set the current_time variable
before MPI initialization */
/* use a special begin_event which do not call MPI W_Time */

a0_perf_init_trace_buffers (*argcp,*argvp);
_a0Init(argcp,argvp);
/* Do not forget to start the flushing dameon */
a0_perf_start_flushing_daemon ();
/* Get the correct current time */
a0_perf_set_current_time;
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_INIT);
a0_perf_put_index;
}


a0tError _a0_perf_InitCommit ()
{
a0_perf_begin_event;
rcode = _a0InitCommit();
a0_perf_get_index;
a0_perf_put_event_id(A0_PERF_RECORD_ID_INITCOMMIT);
a0_perf_put_index;
}

a0tError _a0_perf_Terminate ()
{
/* The job is done within internal_terminate */
return ( _a0Terminate());
}

a0tError _a0_perf_Abort (int err)
{
/* The job is done within internal_terminate */
return (_a0Abort (err));
}


