/*
 *
 * a0_perf_thread.h 
 *
 *
 * by Philippe Waille
 * Apache Project, IMAG, Grenoble, France
 * July 16, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0_PERF_THREAD_H
#define _A0_PERF_THREAD_H


#include "a0semap.h"
#include "a0thread.h"


extern a0tError _a0_perf_YieldThread( void );
extern a0tError _a0_perf_JoinSlave(a0tThread *thread, void **result);
extern a0tError _a0_perf_DetachSlave(a0tThread *thread);
extern a0tError _a0_perf_ExitThread(void *value);

extern a0tError _a0_perf_NewSlave(a0tThread *thread, int sched,
			int prio, long stack, a0tFunction function,
			void *arg);

extern a0tError _a0_perf_NewSemaphore(a0tSemaphore *semap, int value);
extern a0tError _a0_perf_DisposeSemaphore(a0tSemaphore *semap);
extern a0tError _a0_perf_PSemaphore(a0tSemaphore *semap);
extern a0tError _a0_perf_TryPSemaphore(a0tSemaphore *semap, int *success);
extern a0tError _a0_perf_VSemaphore(a0tSemaphore *semap);

extern a0tError _a0_perf_NewMutex(a0tMutex *mutex);
extern a0tError _a0_perf_DisposeMutex(a0tMutex *mutex);
extern a0tError _a0_perf_LockMutex(a0tMutex *mutex);
extern a0tError _a0_perf_UnlockMutex(a0tMutex *mutex);

extern a0tError	_a0_perf_NewContext(a0tContext *context);
extern a0tError	_a0_perf_GetSelfContext(a0tContext *context,void **data);
extern a0tError	_a0_perf_SetSelfContext(a0tContext *context,void *data);

#endif /* _A0_PERF_THREAD_H */
