#include <stdio.h>
#include "a0_perf_decode.h"
#include <stdlib.h> 




extern int a0_define_events;
extern int a0_source;

int print_help =0;
int print_header =0;
extern int nb_files;
extern int check_nb_files;

FILE *adjust_input_file = NULL;

extern file_check check_tab [];

void analyse_args (int argc, char *argv[])
{
int i;
char *adjust_file_name;

nb_files=0;
for (i=1;i<argc;i++)
  {
  if (!strcmp(argv[i],"-h")) 
     {
     print_help =1;
     argv[i][0]='\0'; 
     }
  else if (!strcmp(argv[i],"-wh"))
     {
     print_header =1;
     argv[i][0]='\0'; 
     }
  else if (!strcmp(argv[i],"-ckn"))
     {
     check_nb_files = 1;
     argv[i][0]='\0'; 
     }
  else if (!strncmp(argv[i],"-clock=",7))
     {
     adjust_file_name = (char *) argv[i] + 7;
     argv[i][0]='\0'; 
     adjust_input_file = fopen (adjust_file_name,"r");
     if (adjust_input_file == NULL)
        {
        fprintf (stderr,"Cannot open adjust clock file : %s\n",adjust_file_name);
        exit (1);
        }
     }
  else if (argv[i][0] != '-')
     nb_files ++;
  else
     {
     fprintf(stderr,"Unkown option : %s",argv[i]);
     exit (1);
     }
  }
}

void print_help_message ()
{
fprintf (stderr,"Usage :\n");
fprintf (stderr,"a0expand -h -wh -ckn file1 file2 ...\n");
fprintf (stderr,"\t -h : print help\n");
fprintf (stderr,"\t -wh : print event definition headers\n");
fprintf (stderr,"\t -ckn : check if trace file available for each node \n");
fprintf (stderr,"\t -clock=adjust_file : global clock processing\n\n");
}

void main (int argc,char *argv[])
{
int current_file;
int current_arg;

/* Standard init : file not already processed */
/* Neutral adjust : unity slope and null offset */

for (current_file = 0;current_file <MAX_NODE_NUMBER;current_file++)
    {
    (check_tab[current_file]).is_processed = 0;
    (check_tab[current_file]).slope = 1.0;
    (check_tab[current_file]).offset = 0.0;
    }

/* Standard output : */
fout = stdout;

analyse_args(argc,argv);
if (print_help) print_help_message ();

if ((adjust_input_file != NULL) && (read_adjust_file ())) exit (1);

/*
printf ("time_reference : %f is_defined : %d\n",time_reference,time_reference_is_defined);printf ("Lu noeud 0 : %f %f  1 : %f %f   2: %f,%f\n\n",
	check_tab[0].slope, check_tab[0].offset,
	check_tab[1].slope, check_tab[1].offset,
	check_tab[2].slope, check_tab[2].offset);
*/
if (print_header) a0_perf_write_header ();

a0_perf_init_min_max();

 
if (nb_files >0)
  {
  for (current_arg=1;current_arg <argc;current_arg++)
    if (argv[current_arg][0] != '\0') a0_perf_decode_file (argv[current_arg]);
  
  free (check_tab);
  a0_perf_write_min_max ();
  }
exit (0);
}
