#define SOURCE_PERF_THREAD_H
#ifndef SOURCE_PERF_THREAD_H

#include "a0_perf_thread.h"

extern a0tError _a0_source_perf_YieldThread(char *file_name,int source_line);

extern a0tError _a0_source_perf_JoinSlave(char *file_name,int source_line,
				    a0tThread *thread, void **result);

extern a0tError _a0_source_perf_DetachSlave(char *file_name,int source_line,
                                      a0tThread *thread);

extern a0tError _a0_source_perf_ExitThread(char *file_name,int source_line,void *value);

extern a0tError _a0_source_perf_NewSlave(char *file_name,int source_line,
				  a0tThread *thread, int sched,
			          int prio, long stack, a0tFunction function,
			          void *arg);

extern a0tError _a0_source_perf_NewSemaphore(char *file_name,int source_line,
                                      a0tSemaphore *semap, int value);

extern a0tError _a0_source_perf_DisposeSemaphore(char *file_name,
					int source_line,
				        a0tSemaphore *semap);

extern a0tError _a0_source_perf_PSemaphore(char *file_name,int source_line,
			            a0tSemaphore *semap);

extern a0tError _a0_source_perf_TryPSemaphore(char *file_name,int source_line,
				       a0tSemaphore *semap, int *success);

extern a0tError _a0_source_perf_VSemaphore(char *file_name,int source_line,
				    a0tSemaphore *semap);

extern a0tError _a0_source_perf_NewMutex(char *file_name,int source_line,
				  a0tMutex *mutex);

extern a0tError _a0_source_perf_DisposeMutex(char *file_name,int source_line,
                                      a0tMutex *mutex);

extern a0tError _a0_source_perf_LockMutex(char *file_name,int source_line,
				   a0tMutex *mutex);

extern a0tError _a0_source_perf_UnlockMutex(char *file_name,int source_line,
                                     a0tMutex *mutex);

extern a0tError _a0_source_perf_NewContext(char *file_name,int source_line,
                                        a0tContext *context);

extern a0tError _a0_source_perf_GetSelfContext(char *file_name,int source_line,
                                        a0tContext *context,void **data);

extern a0tError _a0_source_perf_SetSelfContext(char *file_name,int source_line,
                                        a0tContext *context,void *data);

#endif
