/*
 *
 * a0info.h : system information
 *
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * Apr 24, 1997
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0INFO_H
#define _A0INFO_H

/****************defines********************/
/****************types********************/

typedef {		/* level */
  int level;		/* 0 */
  struct {
    struct {
      int comm;		/* 1 */
      int lock;		/* 1 */
    } blocked;
    int created;	/* 0 */
    int running;	/* 0 */
  } threads;
} a0tSystemData;


/****************variables********************/

extern int _a0SystemInformationLevel;


/****************functions********************/

extern a0tError _a0GetSystemData(a0tSystemData *data);


#ifdef A0_SOURCE
/****************************************************************************
		Included only for compiling the lib
****************************************************************************/

#define IfSystemInfo	if (_a0SystemInformationLevel)

extern a0tError _a0AccountThreadsRunning(int i);
extern a0tError _a0AccountThreadsBlockedLock(int i);
extern a0tError _a0AccountThreadsBlockedComm(int i);

/* the system data table */
extern a0tSystemData _a0SystemData;


#endif /* A0_SOURCE */

#endif /* _A0INFO_H */
