
/*
 *
 * _a0init.h : Defines for _a0init.c (Initialization of Athapascan0)
 *
 * by Ilan Ginzburg
 * Apache Project, IMAG, Grenoble, France
 * Feb 21, 1996
 *
 */

/* Eliminates multiple includes of this file */
#ifndef _A0INIT_H
#define _A0INIT_H

#include "a0error.h"

/* Function to be called before ANY other Athapascan call. */
extern a0tError _a0Init(int *argcp, char ***argvp);

/* Function to be called after user inits are done */
extern a0tError _a0InitCommit();

/* Function called by the MAIN thread after the end of the computation.
 * No code may follow this call (this call is not guaranteed to return).
 */
extern a0tError _a0Terminate(void);

/* _a0Abort - terminates abnormally Athapascan */
extern a0tError _a0Abort(int err);

/* Rank of the node in the computation */
extern int a0SelfNode;
/* Number of nodes in the computation */
extern int a0NodeCount;


#ifdef A0_SOURCE
/***************************************************************************
 * Defines only used for compiling Athapascan0
 ***************************************************************************/

#define A0MinStackSize (1024*2)
#define A0MaxStackSize (1024*1024*2)
#define A0TraceRec 1
#define A0TracePlay 2

extern void (*_a0TerminateChain)(void);

#endif /* A0_SOURCE */


#endif /* _A0INIT_H */
