#ifndef ATH0_PERF_NAMESHIFT_H
#define ATH0_PERF_NAMESHIFT_H

/* Defines the a0 primitives not already defined by the user */
/* as perf or source perf primitives */

#ifdef SOURCE_FILE_NAME
/* Source file name defined : translate to sperf primitives */
#define ath0_perf_nameshift(x)	_a0_sperf_ ## x
#else
/* No source file name : standard perf primtives */
#define ath0_perf_nameshift(x)	_a0_perf_ ## x
#endif /* SOURCE_FILE_NAME */


#ifndef a0UserEvent
#define a0UserEvent		ath0_perf_nameshift(UserEvent)
#endif
#ifndef a0Abort
#define a0Abort			ath0_perf_nameshift(Abort)
#endif
#ifndef a0ClearBuffer
#define a0ClearBuffer		ath0_perf_nameshift(ClearBuffer)
#endif
#ifndef a0DetachSlave
#define a0DetachSlave		ath0_perf_nameshift(DetachSlave)
#endif
#ifndef a0DisposeBuffer
#define a0DisposeBuffer		ath0_perf_nameshift(DisposeBuffer)
#endif
#ifndef a0DisposeMutex
#define a0DisposeMutex		ath0_perf_nameshift(DisposeMutex)
#endif
#ifndef a0DisposePort
#define a0DisposePort		ath0_perf_nameshift(DisposePort)
#endif
#ifndef a0DisposeSemaphore
#define a0DisposeSemaphore	ath0_perf_nameshift(DisposeSemaphore)
#endif
#ifndef a0ExitThread
#define a0ExitThread		ath0_perf_nameshift(ExitThread)
#endif
#ifndef a0GetRequestSerialNo
#define a0GetRequestSerialNo	ath0_perf_nameshift(GetRequestSerialNo)
#endif
#ifndef a0GetSelfThreadId
#define a0GetSelfThreadId	ath0_perf_nameshift(GetSelfThreadId)
#endif
#ifndef a0GetThreadId
#define a0GetThreadId		ath0_perf_nameshift(GetThreadId)
#endif
#ifndef a0IReceive
#define a0IReceive		ath0_perf_nameshift(IReceive)
#endif
#ifndef a0IReceiveBuffer
#define a0IReceiveBuffer	ath0_perf_nameshift(IReceiveBuffer)
#endif
#ifndef a0IStartRemoteUrgent
#define a0IStartRemoteUrgent	ath0_perf_nameshift(IStartRemoteUrgent)
#endif
#ifndef a0IStartRemoteThread
#define a0IStartRemoteThread	ath0_perf_nameshift(IStartRemoteThread)
#endif
#ifndef a0ISend
#define a0ISend			ath0_perf_nameshift(ISend)
#endif
#ifndef a0ISendBuffer
#define a0ISendBuffer		ath0_perf_nameshift(ISendBuffer)
#endif
#ifndef a0Init
#define a0Init			ath0_perf_nameshift(Init)
#endif
#ifndef a0InitCommit
#define a0InitCommit		ath0_perf_nameshift(InitCommit)
#endif
#ifndef a0JoinSlave
#define a0JoinSlave		ath0_perf_nameshift(JoinSlave)
#endif
#ifndef a0LockMutex
#define a0LockMutex		ath0_perf_nameshift(LockMutex)
#endif
#ifndef a0NewBuffer
#define a0NewBuffer		ath0_perf_nameshift(NewBuffer)
#endif
#ifndef a0NewMutex
#define a0NewMutex		ath0_perf_nameshift(NewMutex)
#endif
#ifndef a0NewPort
#define a0NewPort		ath0_perf_nameshift(NewPort)
#endif
#ifndef a0NewService
#define a0NewService		ath0_perf_nameshift(NewService)
#endif
#ifndef a0NewSemaphore
#define a0NewSemaphore		ath0_perf_nameshift(NewSemaphore)
#endif
#ifndef a0NewSlave
#define a0NewSlave		ath0_perf_nameshift(NewSlave)
#endif
#ifndef a0PSemaphore
#define a0PSemaphore		ath0_perf_nameshift(PSemaphore)
#endif
#ifndef a0Pack
#define a0Pack			ath0_perf_nameshift(Pack)
#endif
#ifndef a0Receive
#define a0Receive		ath0_perf_nameshift(Receive)
#endif
#ifndef a0ReceiveBuffer
#define a0ReceiveBuffer		ath0_perf_nameshift(ReceiveBuffer)
#endif
#ifndef a0StartRemoteUrgent
#define a0StartRemoteUrgent	ath0_perf_nameshift(StartRemoteUrgent)
#endif
#ifndef a0StartRemoteThread
#define a0StartRemoteThread	ath0_perf_nameshift(StartRemoteThread)
#endif
#ifndef a0Send
#define a0Send			ath0_perf_nameshift(Send)
#endif
#ifndef a0SendBuffer
#define a0SendBuffer		ath0_perf_nameshift(SendBuffer)
#endif
#ifndef a0Terminate
#define a0Terminate		ath0_perf_nameshift(Terminate)
#endif
#ifndef a0TestRequest
#define a0TestRequest		ath0_perf_nameshift(TestRequest)
#endif
#ifndef a0TestAnyRequest
#define a0TestAnyRequest	ath0_perf_nameshift(TestAnyRequest)
#endif
#ifndef a0TryPSemaphore
#define a0TryPSemaphore		ath0_perf_nameshift(TryPSemaphore)
#endif
#ifndef a0UnlockMutex
#define a0UnlockMutex		ath0_perf_nameshift(UnlockMutex)
#endif
#ifndef a0Unpack
#define a0Unpack		ath0_perf_nameshift(Unpack)
#endif
#ifndef a0VSemaphore
#define a0VSemaphore		ath0_perf_nameshift(VSemaphore)
#endif
#ifndef a0WaitRequest
#define a0WaitRequest		ath0_perf_nameshift(WaitRequest)
#endif
#ifndef a0WaitAnyRequest
#define a0WaitAnyRequest	ath0_perf_nameshift(WaitAnyRequest)
#endif
#ifndef a0YieldThread
#define a0YieldThread		ath0_perf_nameshift(YieldThread)
#endif
#ifndef a0Probe
#define a0Probe			ath0_perf_nameshift(Probe)
#endif
#ifndef a0IProbe
#define a0IProbe		ath0_perf_nameshift(IProbe)
#endif
#ifndef a0NewContext
#define a0NewContext		ath0_perf_nameshift(NewContext)
#endif
#ifndef a0GetSelfContext
#define a0GetSelfContext	ath0_perf_nameshift(GetSelfContext)
#endif
#ifndef a0SetSelfContext
#define a0SetSelfContext	ath0_perf_nameshift(SetSelfContext)
#endif


#endif /* ATH0_PERF_NAMESHIFT_H */

