#include "a0_perf_flock.h"
#include "a0flock.h"
#include "../basic/a0_perf_event_codes.h"
#include "../basic/a0_perf_event_macros.h"

a0tError _a0_perf_SetLockRead (a0tLock *lock,int index,a0tFormat *formatp,
				      void *address,int count)
{
a0_perf_begin_event;
rcode = _a0SetLockRead (lock,index,formatp,address,count);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_SETLOCKREAD);
a0_perf_put_index;
}


a0tError _a0_perf_SetUnlockWrite (a0tLock *lock,int index,a0tFormat *formatp,
				      void *address,int count)
{
a0_perf_begin_event;
rcode = _a0SetUnlockWrite (lock,index,formatp,address,count);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_SETUNLOCKWRITE);
a0_perf_put_index;
}

a0tError _a0_perf_SetLockDMARegion (a0tLock *lock,int index,
					   a0tDMARegion *regionp)
{
a0_perf_begin_event;
rcode = _a0SetLockDMARegion (lock,index,regionp);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_SETLOCKDMAREGION);
a0_perf_put_index;
}

a0tError _a0_perf_SetLockDMARegionPart (a0tLock *lock,int index,
		       a0tDMARegion *regionp,int first,int size)
{
a0_perf_begin_event;
rcode = _a0SetLockDMARegionPart (lock,index,regionp,first,size);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_SETLOCKDMAREGIONPART);
a0_perf_put_index;
}

a0tError _a0_perf_Lock(a0tLock *lock, int count, a0tRequest *requestp)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0Lock(lock,count,requestp);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_LOCK);
a0_perf_put_time;
a0_perf_put_index;
}

a0tError _a0_perf_Unlock(a0tLock *lock, int count, a0tRequest *requestp)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0Unlock(lock,count,requestp);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_UNLOCK);
a0_perf_put_time;
a0_perf_put_index;
}

a0tError _a0_perf_ILock(a0tLock *lock, int count, a0tRequest *requestp)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0ILock(lock,count,requestp);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_ILOCK);
a0_perf_put_index;
}

a0tError _a0_perf_IUnlock(a0tLock *lock, int count, 
			 	 a0tRequest *requestp)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0IUnlock(lock,count,requestp);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_IUNLOCK);
a0_perf_put_index;
}

a0tError _a0_perf_IFReadPartLock(a0tLock *lock,
                        a0tDMARegion *region, int start, int size,
                        a0tRequest *reqp,
                        a0tFormat *formatp, void *address, int count)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0IFReadPartLock(lock,region,start,size,reqp,formatp,address,count);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_IFREADPARTLOCK);
a0_perf_put_index;
}

a0tError _a0_perf_FReadPartLock(a0tLock *lock,
                        a0tDMARegion *region, int start, int size,
                        a0tRequest *reqp,
                        a0tFormat *formatp, void *address, int count)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0FReadPartLock(lock,region,start,size,reqp,formatp,address,count);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_FREADPARTLOCK);
a0_perf_put_time;
a0_perf_put_index;
}

a0tError _a0_perf_IFWriteUnlock(a0tLock *lock, a0tRequest *reqp,
                        a0tFormat *formatp, void *address, int count)

{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0IFWriteUnlock(lock,reqp,formatp,address,count);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_IFWRITEUNLOCK);
a0_perf_put_index;
}

a0tError _a0_perf_FWriteUnlock(a0tLock *lock, a0tRequest *reqp,
                        a0tFormat *formatp, void *address, int count)
{
unsigned long serial_no;
a0_perf_begin_event;
rcode = _a0FWriteUnlock(lock,reqp,formatp,address,count);
a0_perf_get_index;
a0_perf_put_event_id (A0_PERF_RECORD_ID_FWRITEUNLOCK);
a0_perf_put_time;
a0_perf_put_index;
}
