#ifndef A0F_PERF_NAMESHIFT_H
#define A0F_PERF_NAMESHIFT_H

/* Defines the a0 primitives not already defined by the user */
/* as perf or source perf primitives */

#ifdef SOURCE_FILE_NAME
/* Source file name defined : translate to sperf primitives */
#define a0f_perf_nameshift(x)   _a0_sperf_ ## x
#else
/* No source file name : standard perf primtives */
#define a0f_perf_nameshift(x)   _a0_perf_ ## x
#endif /* SOURCE_FILE_NAME */

#ifndef a0NewMapFormat
#define a0NewMapFormat		a0f_perf_nameshift(NewMapFormat)
#endif
#ifndef a0SetMapField
#define a0SetMapField		a0f_perf_nameshift(SetMapField)
#endif
#ifndef a0NewDMARegion
#define a0NewDMARegion		a0f_perf_nameshift(NewDMARegion)
#endif
#ifndef a0IFReadPart
#define a0IFReadPart		a0f_perf_nameshift(IFReadPart)
#endif
#ifndef a0FReadPart
#define a0FReadPart		a0f_perf_nameshift(FReadPart)
#endif
#ifndef a0IFRead
#define a0IFRead		a0f_perf_nameshift(IFRead)
#endif
#ifndef a0FRead
#define a0FRead			a0f_perf_nameshift(FRead)
#endif
#ifndef a0IFWritePart
#define a0IFWritePart		a0f_perf_nameshift(IFWritePart)
#endif
#ifndef a0FWritePart
#define a0FWritePart		a0f_perf_nameshift(FWritePart)
#endif
#ifndef a0IFWrite
#define a0IFWrite		a0f_perf_nameshift(IFWrite)
#endif
#ifndef a0FWrite
#define a0FWrite		a0f_perf_nameshift(FWrite)
#endif
#ifndef a0IFCopyPart
#define a0IFCopyPart		a0f_perf_nameshift(IFCopyPart)
#endif
#ifndef a0FCopyPart
#define a0FCopyPart		a0f_perf_nameshift(FCopyPart)
#endif
#ifndef a0IFCopy
#define a0IFCopy		a0f_perf_nameshift(IFCopy)
#endif
#ifndef a0FCopy
#define a0FCopy			a0f_perf_nameshift(FCopy)
#endif
#ifndef a0IFPut
#define a0IFPut			a0f_perf_nameshift(IFPut)
#endif
#ifndef a0FPut
#define a0FPut			a0f_perf_nameshift(FPut)
#endif
#ifndef a0IFGet
#define a0IFGet			a0f_perf_nameshift(IFGet)
#endif
#ifndef a0FGet
#define a0FGet			a0f_perf_nameshift(FGet)
#endif
#ifndef a0Flush
#define a0Flush			a0f_perf_nameshift(Flush)
#endif
#ifndef a0NewPipe
#define a0NewPipe		a0f_perf_nameshift(NewPipe)
#endif
#ifndef a0DisposePipe
#define a0DisposePipe		a0f_perf_nameshift(DisposePipe)
#endif
#ifndef a0GetFormatSize
#define a0GetFormatSize		a0f_perf_nameshift(GetFormatSize)
#endif
#ifndef a0GetFormatOffset
#define a0GetFormatOffset	a0f_perf_nameshift(GetFormatOffset)
#endif
#ifndef a0UseFormats
#define a0UseFormats		a0f_perf_nameshift(UseFormats)
#endif
#ifndef a0DisposeFormat
#define a0DisposeFormat		a0f_perf_nameshift(DisposeFormat)
#endif
#ifndef a0IFSend
#define a0IFSend		a0f_perf_nameshift(IFSend)
#endif
#ifndef a0FSend
#define a0FSend			a0f_perf_nameshift(FSend)
#endif
#ifndef a0IFReceive
#define a0IFReceive		a0f_perf_nameshift(IFReceive)
#endif
#ifndef a0FReceive
#define a0FReceive		a0f_perf_nameshift(FReceive)
#endif
#ifndef a0FPack
#define a0FPack			a0f_perf_nameshift(FPack)
#endif
#ifndef a0FUnpack
#define a0FUnpack		a0f_perf_nameshift(FUnpack)
#endif
#ifndef a0NewFunctionFormat
#define a0NewFunctionFormat	a0f_perf_nameshift(NewFunctionFormat)
#endif
#ifndef a0SetLockRead
#define a0SetLockRead		a0f_perf_nameshift(SetLockRead)
#endif
#ifndef a0SetUnlockWrite
#define a0SetUnlockWrite	a0f_perf_nameshift(SetUnlockWrite)
#endif
#ifndef a0SetLockDMARegion
#define a0SetLockDMARegion	a0f_perf_nameshift(SetLockDMARegion)
#endif
#ifndef a0SetLockDMARegionPart
#define a0SetLockDMARegionPart	a0f_perf_nameshift(SetLockDMARegionPart)
#endif
#ifndef a0Lock
#define a0Lock			a0f_perf_nameshift(Lock)
#endif
#ifndef a0Unlock
#define a0Unlock		a0f_perf_nameshift(Unlock)
#endif
#ifndef a0ILock
#define a0ILock			a0f_perf_nameshift(ILock)
#endif
#ifndef a0IUnlock
#define a0IUnlock		a0f_perf_nameshift(IUnlock)
#endif
#ifndef a0IFReadPartLock
#define a0IFReadPartLock	a0f_perf_nameshift(IFReadPartLock)
#endif
#ifndef a0FReadPartLock
#define a0FReadPartLock		a0f_perf_nameshift(FReadPartLock)
#endif
#ifndef a0IFReadLock
#define a0IFReadLock		a0f_perf_nameshift(IFReadLock)
#endif
#ifndef a0FReadLock
#define a0FReadLock		a0f_perf_nameshift(FReadLock)
#endif
#ifndef a0IFWriteUnlock
#define a0IFWriteUnlock		a0f_perf_nameshift(IFWriteUnlock)
#endif
#ifndef a0FWriteUnlock
#define a0FWriteUnlock		a0f_perf_nameshift(FWriteUnlock)
#endif


#endif	/* A0F_PERF_NAMESHIFT_ H*/
