/*
 *
 * _a0fxdr.h : _a0 xdr functions
 *
 * by Marcelo Pasin
 * Apache Project, IMAG, Grenoble, France
 * May 28, 1996
 *
 */


/* Eliminates multiple includes of this file */
#ifndef _A0FXDR_H
#define _A0FXDR_H

#include <ath0.h>
#include "a0fuser.h"


/****************types********************/

#define A0XdrBufferType (A0ReservedBufferType+1)

typedef a0tError (*a0tPackFunction)(
		a0tBuffer *,
		a0tFormat *, void *, int);

typedef a0tError (*a0tOffsetFunction)(
		a0tFormat *, void *, int,
		void **);

typedef a0tError (*a0tSizeFunction)(
		a0tFormat *, void *, int,
		size_t *);


/****************variables********************/

/****************functions********************/

extern a0tError _a0NewFunctionFormat(a0tFormat *newformatp,
				a0tPackFunction packfun,
				a0tPackFunction unpackfun,
				a0tSizeFunction sizefun,
				a0tOffsetFunction offsetfun);


#ifdef A0F_SOURCE
/****************************************************************************
		Included only for compiling the lib
****************************************************************************/


/****************types********************/

typedef struct _a0tXdr {
  a0tPackFunction	packfun, unpackfun;
  a0tSizeFunction	sizefun;
  a0tOffsetFunction	offsetfun;
} a0tXdr;


/****************functions********************/

#ifdef PUT_IT_BACK_MARCELO
extern a0tError _a0NewXdrVaList(a0tFormat *newformatp, 
			    a0tFormatType maptype, va_list parameters);
#endif

extern a0tError _a0GetXdrSize(a0tFormat *formatp,
			void *address, int count,
			size_t *sizep);

extern a0tError _a0XdrIReceiveCallback(
		a0tPort *port, int src, int tag, a0tRequest *req,
		a0tFormat *formatp, void *address, int count,
		void (*callback)(), void *callback_par);
extern a0tError _a0XdrISendCallback(
		a0tPort *port, int src, int tag, a0tRequest *req,
		a0tFormat *formatp, void *address, int count,
		void (*callback)(), void *callback_par);

extern a0tError _a0XdrPack(a0tBuffer *buffer,
		 a0tFormat *formatp, void *address, int count);
extern a0tError _a0XdrUnpack(a0tBuffer *buffer,
		 a0tFormat *formatp, void *address, int count);

extern a0tError _a0AddXdrSize(a0tBuffer *buffer,
		a0tFormat *formatp, void *address, int count);



#endif /* A0F_SOURCE */

#endif /* _A0FXDR_H */
